import expressions.Addition;
import expressions.BinaryExpression;
import expressions.Brackets;
import expressions.Division;
import expressions.Expression;
import expressions.Literal;
import expressions.Multiplication;
import expressions.Subtraction;
import visitors.EvalVisitor;
import visitors.PrettyPrintVisitor;

public class Main {
    public static void main(String[] args) {
        PrettyPrintVisitor prettyPrinter = new PrettyPrintVisitor();
        EvalVisitor evaluator            = new EvalVisitor();

        Addition addition = new Addition(new Literal(5), new Literal(10));
        Division division = new Division(addition, new Literal(5));

        prettyPrinter.visit(division); // ((5 + 10) / 5)
        evaluator.visit(division);

        System.out.println(" = " + evaluator.getResult());

        division = new Division(new Literal(10), new Literal(5)); // (10 / 5)
        addition = new Addition(new Literal(5), division); // (5 + (10 / 5))

        prettyPrinter.visit(addition);
        evaluator.visit(addition);

        System.out.println(" = " + evaluator.getResult());

        Expression brackets = new Brackets(new Brackets(new Brackets(new Brackets(new Literal(5)))));

        prettyPrinter.visit(brackets);
        evaluator.visit(brackets);

        System.out.println(" = " + evaluator.getResult());

        Expression complex = new Addition(
                new Division(
                        new Multiplication(new Literal(9),
                                new Addition(new Literal(7), new Literal(1))),
                        new Multiplication(new Literal(3), new Literal(2))),
                new Multiplication(new Literal(10),
                        new Subtraction(new Literal(4), new Literal(8)))
        );

        prettyPrinter.visit(complex);
        evaluator.visit(complex);

        System.out.println(" = " + evaluator.getResult());
    }
}
