package visitors;

import expressions.Addition;
import expressions.BinaryExpression;
import expressions.Brackets;
import expressions.Division;
import expressions.Expression;
import expressions.Literal;
import expressions.Multiplication;
import expressions.Subtraction;

public class PrettyPrintVisitor implements Visitor {
    @Override
    public void visit(Expression e) {
        e.accept(this);
    }

    @Override
    public void visit(Literal l) {
        System.out.print(l.getValue());
    }

    @Override
    public void visit(Brackets b) {
        System.out.print("(");
        visit(b.getExpression());
        System.out.print(")");
    }

    @Override
    public void visit(Addition a) {
        System.out.print("(");
        visit(a.getLeftHand());
        System.out.print(" + ");
        visit(a.getRightHand());
        System.out.print(")");
    }

    @Override
    public void visit(Subtraction a) {
        System.out.print("(");
        visit(a.getLeftHand());
        System.out.print(" - ");
        visit(a.getRightHand());
        System.out.print(")");
    }

    @Override
    public void visit(Multiplication a) {
        System.out.print("(");
        visit(a.getLeftHand());
        System.out.print(" * ");
        visit(a.getRightHand());
        System.out.print(")");
    }

    @Override
    public void visit(Division a) {
        System.out.print("(");
        visit(a.getLeftHand());
        System.out.print(" / ");
        visit(a.getRightHand());
        System.out.print(")");
    }
}